CREATE OR REPLACE
PROCEDURE ANALISE_VERTICAL(
  P_CDCONTADOR IN VARCHAR2,
  P_CDEMPRESA IN VARCHAR2,
  P_CONTAINICIAL IN CONTCTBL.CDCONTCTBL%TYPE,
  P_CONTAFINAL IN CONTCTBL.CDCONTCTBL%TYPE,
  P_CDNIVEL IN CONTCTBL.CDNVCONTCTBL%TYPE,
  P_DATAINICIAL IN SALDEMPR.DTSALDEMPR%TYPE,
  P_DATAFINAL SALDEMPR.DTSALDEMPR%TYPE)
AS
   V_COUNTQUEBRA INT;
   V_NRQUEBRA VARCHAR2(03);
   V_COUNT NUMBER;
   V_VRAV NUMBER;
   V_VRAH NUMBER;
   V_VRSALDO NUMBER;
   V_CONTASINT VARCHAR2(02);
   V_CONTAANALISE VARCHAR2(20);

   FUNCTION BUSCAVALORH(P_CDCONTADOR IN VARCHAR2,
                        P_CDCONTCTBL IN VARCHAR2,
                        P_DTDATA IN DATE)RETURN NUMBER
   AS
      V_VALOR NUMBER;
   BEGIN
      V_VALOR := 0;
      BEGIN
         SELECT VRMES1
           INTO V_VALOR
           FROM ANALISEVERTICAL
          WHERE DTMES1 = LAST_DAY(P_DTDATA)
            AND NRQUEBRAREL = '0'
            AND CDCONTADOR = P_CDCONTADOR
            AND CDCONTCTBL = P_CDCONTCTBL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VALOR := 0; 
      END;
      RETURN V_VALOR;
   END;
BEGIN
   DELETE
     FROM ANALISEVERTICAL
    WHERE CDCONTADOR = P_CDCONTADOR;
   /* BUSCA TODAS AS CONTAS CONTBEIS QUE FOI FILTRADA NA TELA
      COMPLETANDO COM 'zzzzzzzzzz' AT 20 POSIES */
   FOR C_CONTA IN
      (SELECT C.CDCONTCTBL, C.NMCONTCTBL, C.CDNVCONTCTBL
         FROM CONTCTBL C
        WHERE C.CDCONTCTBL BETWEEN P_CONTAINICIAL AND P_CONTAFINAL
          AND IDCONTCCUS <> 'R'
          AND ((CDNVCONTCTBL <= P_CDNIVEL) OR ('T' = P_CDNIVEL))
        ORDER BY C.CDCONTCTBL) LOOP

      SELECT CDCONTCTBL
        INTO V_CONTASINT
        FROM CONTCTBL
       WHERE C_CONTA.CDCONTCTBL LIKE CDCONTCTBL || '%'
         AND CDNVCONTCTBL = '1';

      /* VARIAVEIS USADAS PARA CONTROLAR OS MESES QUE IRO APARECER NO
         RELATRIO. O RELATRIO MOSTRA AT 4 MESES SIMULTANEAMENTE */

      V_COUNTQUEBRA := 0;
      V_NRQUEBRA := '0';
      FOR C_DATA IN
         (SELECT NMMES, DTDATA
            FROM (SELECT DISTINCT SUBSTR(TO_CHAR(DTMES, 'MONTH','NLS_DATE_LANGUAGE =''BRAZILIAN PORTUGUESE'''), 1, 3)
                         || ' / ' ||TO_CHAR(DTDATA, 'YY') NMMES,
                         LAST_DAY(DTDATA) DTDATA
                    FROM DATA D
                   WHERE DTDATA BETWEEN TO_DATE('01/'||TO_CHAR(TO_DATE(P_DATAINICIAL), 'MM/YYYY')) AND LAST_DAY(P_DATAFINAL)) D
           WHERE EXISTS (SELECT 1
                           FROM SALDEMPR
                          WHERE ((INSTR(P_CDEMPRESA, CDEMPRESA) > 0) OR ('T' = P_CDEMPRESA))
                            AND DTDATA = DTSALDEMPR)
           ORDER BY 2) LOOP

         BEGIN
            SELECT NVL(SUM(VRSALDEMPR), 0)
              INTO V_VRSALDO
              FROM SALDEMPR
             WHERE CDCONTCTBL = C_CONTA.CDCONTCTBL
               AND DTSALDEMPR = C_DATA.DTDATA
               AND ((INSTR(P_CDEMPRESA, CDEMPRESA) > 0) OR ('T' = P_CDEMPRESA));
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRSALDO := 0;
         END;
         V_COUNTQUEBRA := V_COUNTQUEBRA + 1;
         IF V_COUNTQUEBRA > 4 THEN
            /* CASO CHEGUE A 4 MESES CALCULADOS PARA A CONTA, A QUEBRA  AUMENTADA
               PARA QUE O 5 MS APARECA NA PRXIMA PGINA */
            V_NRQUEBRA := TO_CHAR(TO_NUMBER(V_NRQUEBRA) + 1);
            V_COUNTQUEBRA := 1;
         END IF;

         /* CASO NAO ENCONTRE NENHUM REGISTRO NA TABELA COM A CONTA CONTABIL
            E O NUMERO DA QUEBRA,  PORQUE NO EXISTE O REGISTRO NA TABELA
            PARA OS 4 MESES DA QUEBRA DO RELATORIO, SENDO ASSIM,  PRECISO
            INSERIR NA TABELA O PRIMEIRO MES E POSTERIORMENTE IR ATUALIZANDO
            OS OUTROS MESES AT A PRXIMA QUEBRA DO RELATRIO */
         V_COUNT := 0;
         BEGIN
            SELECT COUNT(*)
              INTO V_COUNT
              FROM ANALISEVERTICAL
             WHERE CDCONTCTBL = C_CONTA.CDCONTCTBL
               AND NRQUEBRAREL = V_NRQUEBRA
               AND CDCONTADOR = P_CDCONTADOR;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_COUNT := 0;
         END;

         IF V_COUNT = 0 THEN
            INSERT INTO ANALISEVERTICAL
               (CDCONTADOR, CDCONTCTBL, DTMES1, DSMES1, VRMES1, NRQUEBRAREL)
            VALUES
               (P_CDCONTADOR, C_CONTA.CDCONTCTBL, C_DATA.DTDATA, C_DATA.NMMES, V_VRSALDO, V_NRQUEBRA);
         ELSE
            CASE V_COUNTQUEBRA
               WHEN 2 THEN
                  BEGIN
                     UPDATE ANALISEVERTICAL
                        SET VRMES2 = V_VRSALDO,
                            DSMES2 = C_DATA.NMMES,
                            DTMES2 = C_DATA.DTDATA
                      WHERE NRQUEBRAREL = V_NRQUEBRA
                        AND CDCONTCTBL = C_CONTA.CDCONTCTBL
                        AND CDCONTADOR = P_CDCONTADOR;
                  END;

               WHEN 3 THEN
                  BEGIN
                     UPDATE ANALISEVERTICAL
                        SET VRMES3 = V_VRSALDO,
                            DSMES3 = C_DATA.NMMES,
                            DTMES3 = C_DATA.DTDATA
                      WHERE NRQUEBRAREL = V_NRQUEBRA
                        AND CDCONTCTBL = C_CONTA.CDCONTCTBL
                        AND CDCONTADOR = P_CDCONTADOR;
                  END;

               WHEN 4 THEN
                  BEGIN
                     UPDATE ANALISEVERTICAL
                        SET VRMES4 = V_VRSALDO,
                            DSMES4 = C_DATA.NMMES,
                            DTMES4 = C_DATA.DTDATA
                      WHERE NRQUEBRAREL = V_NRQUEBRA
                        AND CDCONTCTBL = C_CONTA.CDCONTCTBL
                        AND CDCONTADOR = P_CDCONTADOR;
                  END;
            END CASE;
         END IF;
      END LOOP;
   END LOOP;

   UPDATE ANALISEVERTICAL
      SET VRPORCENTH1 = 0
    WHERE NRQUEBRAREL = '0'
      AND CDCONTADOR = P_CDCONTADOR;

   UPDATE ANALISEVERTICAL A
      SET VRPORCENTV1 = 100,
          VRPORCENTV2 = 100,
          VRPORCENTV3 = 100,
          VRPORCENTV4 = 100
    WHERE EXISTS (SELECT 1
                    FROM CONTCTBL C
                   WHERE C.CDCONTCTBL = A.CDCONTCTBL
                     AND C.CDNVCONTCTBL = '1')
      AND CDCONTADOR = P_CDCONTADOR;


   FOR C_ANALISEV IN
      (SELECT A.CDCONTCTBL, NRQUEBRAREL, VRMES1, VRMES2, VRMES3, VRMES4,
              DTMES1, DTMES2, DTMES3, DTMES4                           
         FROM ANALISEVERTICAL A, CONTCTBL C
        WHERE C.CDCONTCTBL = A.CDCONTCTBL
          AND C.CDNVCONTCTBL <> '1'
          AND CDCONTADOR = P_CDCONTADOR
        ORDER BY NRQUEBRAREL, CDCONTCTBL) LOOP

      V_COUNT := 0;
      V_CONTAANALISE := NULL;
      BEGIN
         SELECT COUNT(*), CDCONTCTBLANALI
           INTO V_COUNT, V_CONTAANALISE
           FROM CONTCTBL
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTCTBLANALI IS NOT NULL
          GROUP BY CDCONTCTBLANALI;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
            V_CONTAANALISE := NULL;
      END;
      V_VRAV := 0;
      IF V_COUNT = 0 THEN
         BEGIN
            SELECT VRMES1
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = (SELECT CDCONTCTBL
                                   FROM CONTCTBL C
                                  WHERE C_ANALISEV.CDCONTCTBL LIKE C.CDCONTCTBL || '%'
                                    AND C.CDNVCONTCTBL = '1')
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES1 = C_ANALISEV.DTMES1;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      ELSE
         BEGIN
            SELECT VRMES1
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = V_CONTAANALISE
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES1 = C_ANALISEV.DTMES1;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      END IF;
      
      IF V_VRAV <> 0 THEN
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV1 = ROUND((VRMES1 * 100) / V_VRAV, 2)
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      ELSE
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV1 = 0
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      END IF;

      V_VRAV := 0;
      IF V_COUNT = 0 THEN
         BEGIN
            SELECT VRMES2
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = (SELECT CDCONTCTBL
                                   FROM CONTCTBL C
                                  WHERE C_ANALISEV.CDCONTCTBL LIKE C.CDCONTCTBL || '%'
                                    AND C.CDNVCONTCTBL = '1')
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES2 = C_ANALISEV.DTMES2;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      ELSE
         BEGIN
            SELECT VRMES2
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = V_CONTAANALISE
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES2 = C_ANALISEV.DTMES2;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      END IF;

      IF V_VRAV <> 0 THEN
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV2 = ROUND((VRMES2 * 100) / V_VRAV, 2)
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      ELSE
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV2 = 0
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      END IF;

      V_VRAV := 0;
      IF V_COUNT = 0 THEN
         BEGIN
            SELECT VRMES3
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = (SELECT CDCONTCTBL
                                   FROM CONTCTBL C
                                  WHERE C_ANALISEV.CDCONTCTBL LIKE C.CDCONTCTBL || '%'
                                    AND C.CDNVCONTCTBL = '1')
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES3 = C_ANALISEV.DTMES3;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      ELSE
         BEGIN
            SELECT VRMES3
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = V_CONTAANALISE
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES3 = C_ANALISEV.DTMES3;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      END IF;
      
      IF V_VRAV <> 0 THEN
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV3 = ROUND((VRMES3 * 100) / V_VRAV, 2)
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      ELSE
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV3 = 0
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      END IF;

      V_VRAV := 0;
      IF V_COUNT = 0 THEN
         BEGIN
            SELECT VRMES4
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = (SELECT CDCONTCTBL
                                   FROM CONTCTBL C
                                  WHERE C_ANALISEV.CDCONTCTBL LIKE C.CDCONTCTBL || '%'
                                    AND C.CDNVCONTCTBL = '1')
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES4 = C_ANALISEV.DTMES4;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      ELSE
         BEGIN
            SELECT VRMES4
              INTO V_VRAV
              FROM ANALISEVERTICAL A
             WHERE CDCONTADOR = P_CDCONTADOR
               AND CDCONTCTBL = V_CONTAANALISE
               AND A.NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL
               AND A.DTMES4 = C_ANALISEV.DTMES4;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRAV := 0;
         END;
      END IF;

      IF V_VRAV <> 0 THEN
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV4 = ROUND((VRMES4 * 100) / V_VRAV, 2)
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      ELSE
         UPDATE ANALISEVERTICAL
            SET VRPORCENTV4 = 0
          WHERE CDCONTCTBL = C_ANALISEV.CDCONTCTBL
            AND CDCONTADOR = P_CDCONTADOR
            AND NRQUEBRAREL = C_ANALISEV.NRQUEBRAREL;
      END IF;
   END LOOP;

   FOR C_ANALISE_H IN
      (SELECT  NRQUEBRAREL, CDCONTCTBL, DTMES1, VRMES1,
               DTMES2, VRMES2, DTMES3, VRMES3,
               DTMES4, VRMES4
         FROM ANALISEVERTICAL A
        WHERE CDCONTADOR = P_CDCONTADOR
        ORDER BY NRQUEBRAREL, CDCONTCTBL) LOOP

       V_VRAH := BUSCAVALORH(P_CDCONTADOR, C_ANALISE_H.CDCONTCTBL, P_DATAINICIAL);

       IF V_VRAH <> 0 THEN
          UPDATE ANALISEVERTICAL
             SET VRPORCENTH1 = ROUND((VRMES1 * 100) / V_VRAH, 2)
           WHERE CDCONTADOR = P_CDCONTADOR
             AND CDCONTCTBL = C_ANALISE_H.CDCONTCTBL
             AND NRQUEBRAREL = C_ANALISE_H.NRQUEBRAREL
             AND DTMES1 = C_ANALISE_H.DTMES1
             AND NRQUEBRAREL <> '0';

          UPDATE ANALISEVERTICAL
             SET VRPORCENTH2 = ROUND((VRMES2 * 100) / V_VRAH, 2)
           WHERE CDCONTADOR = P_CDCONTADOR
             AND CDCONTCTBL = C_ANALISE_H.CDCONTCTBL
             AND NRQUEBRAREL = C_ANALISE_H.NRQUEBRAREL
             AND DTMES2 = C_ANALISE_H.DTMES2;

          UPDATE ANALISEVERTICAL
             SET VRPORCENTH3 = ROUND((VRMES3 * 100) / V_VRAH, 2)
           WHERE CDCONTADOR = P_CDCONTADOR
             AND CDCONTCTBL = C_ANALISE_H.CDCONTCTBL
             AND NRQUEBRAREL = C_ANALISE_H.NRQUEBRAREL
             AND DTMES3 = C_ANALISE_H.DTMES3;

           UPDATE ANALISEVERTICAL
             SET VRPORCENTH4 = ROUND((VRMES4 * 100) / V_VRAH, 2)
           WHERE CDCONTADOR = P_CDCONTADOR
             AND CDCONTCTBL = C_ANALISE_H.CDCONTCTBL
             AND NRQUEBRAREL = C_ANALISE_H.NRQUEBRAREL
             AND DTMES4 = C_ANALISE_H.DTMES4;
       END IF;
    END LOOP;

    DELETE
      FROM ANALISEVERTICAL A
     WHERE CDCONTADOR = P_CDCONTADOR
       AND NVL(VRMES1, 0) = 0
       AND NVL(VRMES2, 0) = 0
       AND NVL(VRMES3, 0) = 0
       AND NVL(VRMES4, 0) = 0
       AND NOT EXISTS (SELECT 1
                         FROM CONTCTBL C
                        WHERE C.CDCONTCTBL = A.CDCONTCTBL
                          AND C.CDNVCONTCTBL = '1');
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ANALISE_VERTICAL','5.70.xxx'); END;
/
